<!DOCTYPE html>
<html lang="en" xmlns:th="http://www.thymeleaf.org"
      xmlns:layout="http://www.ultraq.net.nz/thymeleaf/layout"
      xmlns:sec="http://www.thymeleaf.org/extras/spring-security"
      layout:decorate="~{layoutadmin}">
<head>
    <meta charset="UTF-8">
    <title>Penilaian</title>
    <style>
        .loading{
            display: none;
            position: fixed;
            top: 0;
            left: 0;
            width: 100%;
            height: 100%;
            background: rgba(0,0,0,0.5);
            z-index: 999;
        }

        .loading-content {
            position: absolute;
            top: 50%;
            left: 50%;
            transform: translate(-50%, -50%);
            background: white;
            padding: 20px;
            border-radius: 5px;
            text-align: center;
            box-shadow: 0 2px 10px rgba(0,0,0,0.1);
        }

        .spinner {
            width: 40px;
            height: 40px;
            border: 4px solid #f3f3f3;
            border-top: 4px solid #3498db;
            border-radius: 50%;
            animation: spin 1s linear infinite;
            margin: 0 auto 10px;
        }

        @keyframes spin {
            0% { transform: rotate(0deg); }
            100% { transform: rotate(360deg); }
        }
    </style>
</head>
<body>
<div layout:fragment="main">
    <div class="header bg-gradient-primary pb-8 pt-5 pt-md-8">
        <div class="container-fluid">
            <div class="header-body">
                <!-- Card stats -->
                <div class="row">
                    <div class="col-xl-12 col-lg-12">
                        <div class="card card-stats mb-4 mb-xl-0">
                            <div class="card-body">
                                <div class="row">
                                    <div class="col">
                                        <h5 class="card-title text-uppercase text-muted mb-0">Score</h5>
                                        <span class="h2 font-weight-bold mb-0">Penilaian </span>
                                    </div>
                                    <div class="col-auto">
                                        <div class="icon icon-shape bg-gradient-blue text-white rounded-circle shadow">
                                            <i class="fas fa-user-astronaut"></i>
                                        </div>
                                    </div>
                                </div>

                            </div>
                        </div>
                    </div>

                </div>
            </div>
        </div>
    </div>

    <div class="container-fluid mt--7">
        <div class="row">
            <div class="col">
                <div class="card shadow">
                    <div class="card-header border-0">
                        <h3 class="mb-0">Form</h3>
                    </div>
                    <div class="card-body">
                        <div class="row">
                            <div class="col-md-4">
                                <a href="#" style="width: 100%;" class="btn btn-primary">Pembobotan</a>
                            </div>
                            <div class="col-md-4">
                                <a th:href="@{/studiesActivity/assesment/score (jadwal = ${jadwal.id})}"
                                   th:if="${jadwal.finalStatus != 'FINAL'}" style="width: 100%;"
                                   class="btn btn-secondary">Penilaian</a>
                                <a th:href="@{/studiesActivity/assesment/rekap(jadwal = ${jadwal.id})}"
                                   th:if="${jadwal.finalStatus == 'FINAL'}" style="width: 100%;"
                                   class="btn btn-secondary">Rekap Penilaian</a>
                            </div>
                            <div class="col-md-4">
                                <a th:href="@{/studiesActivity/assesment/list}" style="width: 100%;"
                                   class="btn btn-secondary">Kembali</a>
                            </div>

                        </div>
                    </div>
                    <div class="table-responsive">
                        <table class="table align-items-center table-flush">
                            <thead class="thead-light">
                            <tr>
                                <th><b class="mb-0">Tahun Akademik</b></th>
                                <th style="width: 0px;">:</th>
                                <th th:text="${jadwal.tahunAkademik.namaTahunAkademik}">2019/2020 Semester Ganjil</th>

                                <th><b class="mb-0">Program Studi</b></th>
                                <th style="width: 0px;">:</th>
                                <th th:text="${jadwal.prodi.namaProdi}">Ekonomi Syariah</th>
                            </tr>
                            </thead>
                            <thead>
                            <tr>
                                <th><b class="mb-0">Mata Kuliah</b></th>
                                <th style="width: 0px;">:</th>
                                <th th:text="${jadwal.matakuliahKurikulum.matakuliah.namaMatakuliah}">Basic
                                    Econometrics
                                </th>

                                <th><b class="mb-0">Dosen</b></th>
                                <th style="width: 0px;">:</th>
                                <th th:text="${jadwal.dosen.karyawan.namaKaryawan}">Aam Slamet Rusydiana</th>
                            </tr>
                            </thead>
                            <thead class="thead-light">
                            <tr>
                                <th><b class="mb-0">SKS</b></th>
                                <th style="width: 0px;">:</th>
                                <th><span th:text="${jadwal.matakuliahKurikulum.jumlahSks}"></span> , Peserta : <span
                                        th:text="${jumlahMahasiswa}"></span> , Absensi Dosen : <span
                                        th:text="${absensi}"></span></th>

                                <th><b class="mb-0">Kelas</b></th>
                                <th style="width: 0px;">:</th>
                                <th th:text="${jadwal.kelas.namaKelas}">ES-18-R</th>
                            </tr>
                            </thead>
                            <thead>
                            <tr>
                                <th><b class="mb-0">Jadwal Kuliah</b></th>
                                <th style="width: 0px;">:</th>
                                <th>
                                    <span th:text="${jadwal.hari.namaHariEng}"></span>
                                    <small style="font-size: 8px"
                                           th:text="${jadwal.jamMulai + ' - ' + jadwal.jamSelesai}">13.00-15.00</small>
                                </th>

                            </tr>
                            </thead>
                        </table>
                    </div>

                    <div class="card-body">

                        <div class="alert alert-danger" id="error-message" style="display: none">
                        </div>
                        <div class="alert alert-danger" th:if="${gaadapres != null}">
                            Anda belum pernah masuk untuk mengajar
                        </div>
                        <div class="alert alert-danger" th:if="${gagal != null}">
                            Save data gagal, total bobot tidak boleh lebih dari 100%....
                        </div>

                        <div class="alert alert-warning" th:if="${jadwal.finalStatus == 'FINAL'}">
                            Data sudah difinalisasi, Anda tidak dapat mengubah nilai
                        </div>

                        <div class="card shadow" th:if="${jadwal.finalStatus != 'FINAL'}">
                            <div class="card-header border-0">
                                <h3 class="mb-0">Bobot Penilaian</h3>
                            </div>
                            <div class="card-body">
                                <div class="row">
                                    <div class="col-md-6 col-xs-12">
                                        <div class="card shadow">
                                            <form id="myForm" th:action="@{/studiesActivity/assesment/weight}"
                                                  method="post" th:object="${jadwal}">
                                                <div class="table-responsive">
                                                    <table class="table align-items-center table-flush">
                                                        <thead>
                                                        <tr>
                                                            <td><h5 class="mb-1">SDS</h5></td>
                                                            <td th:if="${jadwal.matakuliahKurikulum.sds != null}"><input
                                                                    type="text" name="sds"
                                                                    th:value="${jadwal.matakuliahKurikulum.sds}"
                                                                    disabled class="form-control"></td>
                                                            <td th:if="${jadwal.matakuliahKurikulum.sds == null}"><input
                                                                    type="text" name="sds" th:value="${0}" disabled
                                                                    class="form-control"></td>
                                                        </tr>
                                                        </thead>
                                                        <thead>
                                                        <tr>
                                                            <td><h5 class="mb-1">Presensi</h5></td>
                                                            <td><input type="text" id="presensi" name="presensi"
                                                                       th:field="*{bobotPresensi}" class="form-control" disabled>
                                                            </td>
                                                        </tr>
                                                        </thead>
                                                        <thead>
                                                        <tr>
                                                            <td><h5 class="mb-1">Tugas</h5></td>
                                                            <td><input type="text" id="tugas" name="tugas"
                                                                       th:field="*{bobotTugas}" class="form-control">
                                                            </td>
                                                        </tr>
                                                        </thead>
                                                        <thead>
                                                        <tr>
                                                            <td><h5 class="mb-1">Ujian Tengah Semester</h5></td>
                                                            <td><input type="text" id="uts" name="uts"
                                                                       th:field="*{bobotUts}" class="form-control"></td>
                                                        </tr>
                                                        </thead>
                                                        <thead>
                                                        <tr>
                                                            <td><h5 class="mb-1">Ujian Akhir Semester</h5></td>
                                                            <td><input type="text" id="uas" name="uas"
                                                                       th:field="*{bobotUas}" class="form-control"></td>
                                                        </tr>
                                                        </thead>
                                                        <thead>
                                                        <tr>
                                                            <td></td>
                                                            <td>
                                                                <button type="submit" class="btn btn-primary">Save
                                                                </button>
                                                            </td>
                                                        </tr>
                                                        </thead>
                                                    </table>
                                                </div>
                                                <input type="hidden" name="jadwal" th:value="${jadwal.id}">
                                            </form>
                                        </div>

                                    </div>


                                </div>
                                <div class="row" style="padding-top: 10px;">
                                    <div class="col-md-12 col-xs-12">
                                        <div class="card shadow">
                                            <div class="card-header border-0">
                                                <div class="row">
                                                    <div class="col-md-1 col-sm-6 col-xs-12">
                                                        <a th:if="${jadwal.bobotTugas != 0 || jadwal.bobotUts != 0 || jadwal.bobotUas != 0}" th:href="@{/studiesActivity/assesment/tugas(jadwal=${jadwal.id})}" class="btn btn-warning btn-sm">
                                                            <i class="fas fa-plus-circle"></i> Buat tugas
                                                        </a>
                                                    </div>
                                                    <div class="col-md-2 col-sm-6 col-xs-12">
                                                        <form id="form-recalculate" method="post" th:action="@{/studiesActivity/assesment/recalculate}">
                                                            <input type="hidden" name="jadwal" th:value="${jadwal.id}">
                                                            <button th:if="${!#lists.isEmpty(bobot)}" class="btn btn-info btn-sm" id="btn-recalculate">
                                                                <i class="fas fa-calculator"></i> Recalculate Nilai
                                                            </button>
                                                        </form>
                                                    </div>
                                                </div>

                                                <p th:if="${jadwal.bobotTugas == 0 && jadwal.bobotUts == 0 && jadwal.bobotUas == 0}"><b>*</b>Input bobot penilaian terlebih dahulu sebelum membuat tugas</p>

                                                <!-- Loader -->
                                                <div id="loadingOverlay" class="loading">
                                                    <div class="loading-content">
                                                        <div class="spinner"></div>
                                                        <p>Sedang memproses...</p>
                                                    </div>
                                                </div>
                                            </div>


                                            <div class="table-responsive">
                                                <table class="table align-items-center table-flush">
                                                    <thead class="thead-light">
                                                    <tr>
                                                        <th>#</th>
                                                        <th class="text-center">Pertemuan Ke :</th>
                                                        <th>Nama Tugas</th>
                                                        <th>Bobot Tugas</th>
                                                        <th>Kategori Tugas</th>
                                                        <th>Waktu Mulai</th>
                                                        <th>Tenggat Pengumpulan</th>
                                                        <th></th>
                                                    </tr>
                                                    </thead>
                                                    <tbody>
                                                    <tr th:each="data,row : ${bobot}">
                                                        <td th:text="${row.index + 1}">#</td>
                                                        <td class="text-center" th:text="${data.pertemuanKe}">Ruangan</td>
                                                        <td th:text="${data.namaTugas}">Jam</td>
                                                        <td th:text="${data.bobot}">Matakuliah</td>
                                                        <td th:text="${data.kategoriTugas}">Matakuliah</td>
                                                        <td th:text="${#temporals.format(data.waktuMulai, 'dd - MMM - yyyy HH:mm')}">Matakuliah</td>
                                                        <td th:text="${#temporals.format(data.tenggatWaktu, 'dd - MMM - yyyy HH:mm')}">Matakuliah</td>
                                                        <td>
<!--                                                            <div class="badge badge-danger">Bobot harus di isi untuk menilai tugas</div>-->
                                                            <a th:if="${data.bobot != null}" th:href="@{/studiesActivity/assesment/collection (jadwalTugas = ${data.id})}" class="btn btn-info btn-sm"><i class="fas fa-list"></i></a>
                                                            <a th:href="@{/studiesActivity/assesment/edit (id = ${data.id})}" class="btn btn-primary btn-sm"><i class="fas fa-editfas fa-edit"></i></a>
                                                            <button type="button" class="btn btn-danger btn-sm" data-toggle="modal" th:data-target="${'#modal-notification'+data.id}">
                                                                <i class="fas fa-trash"></i>
                                                            </button>

                                                            <div class="modal fade" th:id="${'modal-notification'+data.id}" tabindex="-1" role="dialog" aria-labelledby="modal-notification" aria-hidden="true">
                                                                <div class="modal-dialog modal-danger modal-dialog-centered modal-" role="document">
                                                                    <div class="modal-content bg-gradient-danger">

                                                                        <div class="modal-header">
                                                                            <h6 class="modal-title" id="modal-title-notification">Your attention is required</h6>
                                                                            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                                                                <span aria-hidden="true">×</span>
                                                                            </button>
                                                                        </div>

                                                                        <div class="modal-body">

                                                                            <div class="py-3 text-center">
                                                                                <i class="far fa-trash-alt fa-3x"></i>
                                                                                <h4 class="heading mt-4">Are you sure ?</h4>
                                                                                <p>Once deleted, you will not be able to recover this imaginary file!</p>
                                                                            </div>

                                                                        </div>

                                                                        <div class="modal-footer">
                                                                            <form th:action="@{/studiesActivity/assesment/delete (id = ${data.id})}" method="post">
                                                                                <button type="submit" class="btn btn-white">Delete</button>
                                                                            </form>
                                                                            <button type="button" class="btn btn-link text-white ml-auto" data-dismiss="modal">Close</button>
                                                                        </div>

                                                                    </div>
                                                                </div>
                                                            </div>
                                                        </td>

                                                    </tr>
                                                    </tbody>

                                                </table>
                                            </div>
                                        </div>


                                    </div>
                                </div>

                            </div>
                        </div>
                    </div>
                </div>

            </div>
        </div>
    </div>
</div>
</body>
</html>
<script>

    $(document).ready(function (){
        $('#form-recalculate').on('submit', function (){
            $('#loadingOverlay').show();

            $('#btn-recalculate').prop('disabled', true);

            return true;
        });
    });

    // async function handleRecalculate(id){
    //     const loadingOverlay = document.getElementById('loadingOverlay');
    //     try {
    //         loadingOverlay.style.display = 'block';
    //
    //         // Ambil CSRF token
    //         const csrfInput = document.querySelector('input[name="_csrf"]');
    //         const csrfToken = csrfInput ? csrfInput.value : '';
    //
    //         const response = await fetch(`/studiesActivity/assesment/recalculate/${id}`, {
    //             method: 'POST',
    //             headers: {
    //                 'Content-Type': 'application/json',
    //                 'X-CSRF-TOKEN': csrfToken
    //             }
    //         });
    //
    //         if (!response.ok) {
    //             throw new Error(`HTTP error! status: ${response.status}`);
    //         }
    //
    //         const data = await response.json();
    //         console.log('Success:', data);
    //
    //         location.reload();
    //
    //     }catch (error){
    //         console.error('Error:', error);
    //     }finally {
    //         loadingOverlay.style.display = 'none';
    //     }
    // }
</script>
<script>
    function validateForm(event) {
        // Ambil nilai dari setiap input
        var presensi = parseFloat(document.getElementById('presensi').value) || 0;
        var tugas = parseFloat(document.getElementById('tugas').value) || 0;
        var uts = parseFloat(document.getElementById('uts').value) || 0;
        var uas = parseFloat(document.getElementById('uas').value) || 0;

        // Hitung total nilai
        var total = presensi + tugas + uts + uas;

        // Dapatkan elemen untuk menampilkan pesan kesalahan
        var errorDiv = document.getElementById('error-message');

        // Cek apakah total sesuai dengan kriteria
        if (total !== 100) {
            errorDiv.innerText = 'Total nilai harus 100. Total saat ini: ' + total + '. Silakan perbaiki.';
            errorDiv.style.display = 'block'; // Tampilkan pesan kesalahan
            event.preventDefault(); // Mencegah pengiriman formulir
            return false;
        } else {
            errorDiv.innerText = ''; // Kosongkan pesan kesalahan jika validasi berhasil
            errorDiv.style.display = 'none'; // Sembunyikan pesan kesalahan
        }

        return true;
    }

    document.addEventListener('DOMContentLoaded', function () {
        document.getElementById('myForm').addEventListener('submit', validateForm);
    });
</script>